<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Brick braker game</title>
</head>
<body>
        <h1>Bricks breaker game</h1>
    <script>
        var speed;
var smileyFaceStep;
var smileyFaceX, smileyFaceY;
var smileyFaceSize;
var paletteSize;
var palettePlaceY;
var paletteWidht;
var canvasX = 400;
var canvasY = 400;
var array;
var r;
var brickRows;
var brickWidth;

function setup() {
  createCanvas(canvasX, canvasY);
  speed = 6;
  smileyFaceStepX = speed;
  smileyFaceStepY = -speed;
  smileyFaceX = canvasX / 2;
  smileyFaceY = canvasY / 2;
  smileyFaceSize = 30;
  paletteSize = 105;
  paletteWidht = 10;
  palettePlaceY = canvasY - (paletteWidht + 15);
  array = [];
  brickWidth = 20;
  brickRows = 6;
  r = canvasX / 50;
  for (i = 0; i < r * brickRows; i++) {
    if (i % 3 == 0 && i % 5 == 0) array[i] = 3;
    else array[i] = 1;
    if (i % 6 == 0) array[i] = 2;
  }
}

function palette(x) {
  rect(mouseX - paletteSize / 2, palettePlaceY, paletteSize, paletteWidht);
}

function bricks() {
  var s = 0,
    t = 0;
  for (i = 0; i < r * brickRows; i++) {
    if (array[i] == 1) {
      fill('white');
      rect(s * 50, t, 50, brickWidth);
    }
    if (array[i] == 2) {
      fill('red');
      rect(s * 50, t, 50, brickWidth);
    }
    if (array[i] == 3) {
      fill('black');
      rect(s * 50, t, 50, brickWidth);
    }
    if (s == r - 1) {
      s = 0;
      t += brickWidth;
    } else s++;
  }
}

function smileyFace(x, y) {

  fill('yellow');
  circle(x, y, smileyFaceSize);
  fill('lightblue');
  circle(x + smileyFaceSize / 5, y - smileyFaceSize / 10, smileyFaceSize / 3);
  circle(x - smileyFaceSize / 5, y - smileyFaceSize / 10, smileyFaceSize / 3);
  fill('white');
  circle(x + smileyFaceSize / 3.25, y - smileyFaceSize / 16.6, smileyFaceSize / 10);
  circle(x - smileyFaceSize / 3.25, y - smileyFaceSize / 7.14, smileyFaceSize / 10);
  arc(x, y + smileyFaceSize / 5, smileyFaceSize / 2, smileyFaceSize / 5, 0, PI);
  fill('red');
  arc(x, y + smileyFaceSize / 4, smileyFaceSize / 5, smileyFaceSize / 3.33, 0, PI);
}

function draw() {
  var s = 0,
    t = brickWidth;
  background('lightblue');
  if (smileyFaceY < palettePlaceY) {
    if (smileyFaceX > canvasX - smileyFaceSize / 2 || smileyFaceX < smileyFaceSize / 2) {
      smileyFaceStepX *= -1;
    }
    if (smileyFaceY <= smileyFaceSize / 2) {
      smileyFaceStepY *= -1;
    }

    if (smileyFaceY > palettePlaceY - smileyFaceSize / 2 && (smileyFaceX > mouseX - paletteSize / 2 &&
        smileyFaceX < mouseX)) {
      if (smileyFaceX > mouseX - paletteSize / 4 &&
        smileyFaceX < mouseX)
        smileyFaceStepX = -speed / 4;
      else smileyFaceStepX = -speed;
      smileyFaceStepY *= -1;
    }

    if (smileyFaceY > palettePlaceY - smileyFaceSize / 2 && (smileyFaceX > mouseX &&
        smileyFaceX < mouseX + paletteSize / 2)) {
      if (smileyFaceX > mouseX &&
        smileyFaceX < mouseX + paletteSize / 4) smileyFaceStepX = speed / 4;
      else smileyFaceStepX = speed;
      smileyFaceStepY *= -1;
    }



    for (i = 0; i < r * brickRows; i++) {
      {
        if (smileyFaceX + smileyFaceSize / 2 >= s * 50 && smileyFaceX - smileyFaceSize / 2 < s * 50 + 50 && smileyFaceY / 2 < t)
          if (array[i] != 0) {
            smileyFaceStepY *= -1;
            array[i] -= 1;
            i = r * brickRows;
          }
        else array[i] = 0;
      }
      if (s == r - 1) {
        s = 0;
        t += brickWidth / 2
      } else s++;
    }
    smileyFaceX += smileyFaceStepX;
    smileyFaceY += smileyFaceStepY;
    smileyFace(smileyFaceX, smileyFaceY);
    palette();
    bricks();
  } else {
    smileyFaceX += smileyFaceStepX;
    smileyFaceY += smileyFaceStepY;
    smileyFace(smileyFaceX, smileyFaceY);
    palette();
  }

}
    </script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/1.2.0/p5.min.js" integrity="sha512-b/htz6gIyFi3dwSoZ0Uv3cuv3Ony7EeKkacgrcVg8CMzu90n777qveu0PBcbZUA7TzyENGtU+qZRuFAkfqgyoQ==" crossorigin="anonymous"></script>
</body>
</html>